/* Embedded Server */

#ifndef __INTERNAL_SERVER_H__
#define __INTERNAL_SERVER_H__

LIBMEMCACHED_LOCAL
memcached_return
internal_send(memcached_st *ptr,
              const char *key, size_t key_length,
              const char *value, size_t value_length,
              time_t expiration,
              uint32_t flags,
              uint64_t cas,
              memcached_storage_action verb);


LIBMEMCACHED_LOCAL
memcached_return internal_mget(memcached_st *ptr,
                               const char * const *keys,
                               const size_t *key_length,
                               unsigned int number_of_keys);

LIBMEMCACHED_LOCAL
memcached_return internal_fetch(memcached_st *ptr, memcached_result_st *result);

LIBMEMCACHED_LOCAL
memcached_return internal_delete(memcached_st *ptr, const char *key, size_t size_t);

LIBMEMCACHED_LOCAL
memcached_return internal_dump(memcached_st *ptr, memcached_dump_func *callback, void *context, uint32_t number_of_callbacks);

LIBMEMCACHED_LOCAL
memcached_return internal_increment(memcached_st *ptr,
                                    const char *key, size_t key_length,
                                    uint32_t offset,
                                    uint64_t *value);
LIBMEMCACHED_LOCAL
memcached_return internal_decrement(memcached_st *ptr,
                                    const char *key, size_t key_length,
                                    uint32_t offset,
                                    uint64_t *value);

LIBMEMCACHED_LOCAL
void internal_cursor_reset(memcached_st *ptr);

#endif /* __INTERNAL_SERVER_H__ */
